mod Ex02b

incl Mtex

incl Mtexrc

incl Mauxb

loc rem 
  \para \bf  2. CVICENIE Z PREDMETU 1-AIN-625 UVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMATOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 30.9.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/0809zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane primitivne 
  rekurzivnym funkciam (ohranicena minimalizacia, p.r. predikaty, spatna 
  rekurzia). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor(y) \it  mtex*.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuje definicie niektorych 
         funkcii a predikatov. 
   \item \para Subor(y) \it  ex*.cl  \end obsahuje ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohy v tomto subore: 0 
   \item \para Pocet bodov za premiove ulohy v tomto subore: 1 
  \end
  \para Odovzdat do 6.10.2008 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end Downloadable lecture notes available through the 
         web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  [CL] Remark.  \end Do not use the non-strict version of the 
  function \ft D \end from the module \it  Standard  \end; it plays the role of 
  \it  if-then-else  \end construct. Use the function \ft D1(x,y,z) \end defined 
  in the module \it  Maux*  \end with prefix name \it  D1  \end. 

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end See [1]. 

rem 
  \para \bf  Section. Exercises.  \end 

rem 
  \para \bf  Backward recursion.  \end Show that primitive recursive functions 
  are closed under backward recursion for the following special cases. 

theory Backward_recursion1

fun G 'Tex_f1_g'

fun/3 H1 'Tex_f3_h'

fun B 'Tex_f1_b'

rem 
  \para \bf  Exercise.  \end \header* fun/2 F 'Tex_f2_f' \end Show that if 
  \ft G(y) \end, \ft H1(x,z,y) \end and \ft B(y) \end are all primitive 
  recursive then so is \ft F(x,y) \end defined by 

fun/2 F 'Tex_f2_f'
  F(x,y) = G(y) <- x >= B(y)
  F(x,y) = H1(x,F(x+1,y),y) <- x < B(y)

rem 
  \para \it  Hint.  \end \header* fun/2 F1 'Tex_f2_tilde_f' \end Define 
  \ft F(x,y) \end with the help of a binary p.r. function \ft F1(v,y) \end such 
  that 
  \eq* 
    v+x = B(y) -> F1(v,y) = F(x,y)
  \end

fun/2 F1 'Tex_f2_tilde_f'
  F1(v,y) = Foo

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Backward_recursion1

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _1  \end 

theory Backward_recursion2

fun/2 G 'Tex_f2_g'

fun/3 H1 'Tex_f3_h'

fun B 'Tex_f1_b'

rem 
  \para \bf  Exercise. \it  (bonus 1 point)  \end  \end 
  \header* fun/2 F 'Tex_f2_f' \end Show that if \ft G(x,y) \end, 
  \ft H1(x,z,y) \end and \ft B(y) \end are all primitive recursive then so is 
  \ft F(x,y) \end defined by 

fun/2 F 'Tex_f2_f'
  F(x,y) = G(x,y) <- x >= B(y)
  F(x,y) = H1(x,F(x+1,y),y) <- x < B(y)

rem 
  \para \it  Hint.  \end \header* fun/2 F1 'Tex_f2_tilde_f' \end Define 
  \ft F(x,y) \end with the help of a binary p.r. function \ft F1(v,y) \end such 
  that 
  \eq* 
    v+x = B(y) -> F1(v,y) = F(x,y)
  \end

fun/2 F1 'Tex_f2_tilde_f'
  F1(v,y) = Foo

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Backward_recursion2

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation and set \it  
  component identifier suffix  \end to the string \it  _2  \end 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

